/**************************************************
 * VRML++ Preprocessor2.0 Parser
 * Copyright (C) 1996 Stephan Diehl
 *
 **************************************************
 */

//
// The ParseTreeNode class is responsible for storing information about
// each node in the parse-tree
//


#include "vrmlnode.h"
#include <iostream.h>
#include <stdio.h>
#include <assert.h>
#include <string.h>

#define NULL 0

ParseTreeNode::ParseTreeNode(const char *nm)
{ if (nm != NULL)
    { name = strdup(nm); }
   else
    { name = NULL; }
  ftype=0;  
  classname="";
}

ParseTreeNode::ParseTreeNode(const char *nm, int t)
{  if (nm != NULL)
    { name = strdup(nm); }
   else
   { name = NULL; }
  type = t;
  ftype = 0;
  classname="";
}

ParseTreeNode::~ParseTreeNode()
{ if (name!=NULL) free(name);
}

void ParseTreeNode::addChild(ParseTreeNode *p)
 { children.push_back(p);
 }

void ParseTreeNode::addChild_front(ParseTreeNode *p)
 { children.push_front(p);
 }

void ParseTreeNode::setChildren(list<ParseTreeNode*> l)
 { children=l;
 } 

list<ParseTreeNode*> ParseTreeNode::getChildren(void)
 { return children; 
 }

ParseTreeNode* parsetree;


ParseTreeNode* pt_node(int type, const char* name)
{ ParseTreeNode* pt;
  pt=new ParseTreeNode(name,type);
  return pt;
}

ParseTreeNode* pt_node(int type, const char* name, ParseTreeNode* p1)
{ ParseTreeNode* pt;
  pt=pt_node(type,name);
  pt->addChild(p1);
  return pt;
}

ParseTreeNode* pt_node(int type, const char* name, ParseTreeNode* p1,
                       ParseTreeNode* p2)
{ ParseTreeNode* pt;
  pt=pt_node(type,name,p1);
  pt->addChild(p2);
  return(pt);
}

ParseTreeNode* pt_node(int type, const char* name, ParseTreeNode* p1,
                       ParseTreeNode* p2, ParseTreeNode* p3)
{ ParseTreeNode* pt;
  pt=pt_node(type,name,p1,p2);
  pt->addChild(p3);
  return(pt);
}

ParseTreeNode* pt_node(int type, const char* name, ParseTreeNode* p1,
                       ParseTreeNode* p2, ParseTreeNode* p3, ParseTreeNode* p4)
{ ParseTreeNode* pt;
  pt=pt_node(type,name,p1,p2,p3);
  pt->addChild(p4);
  return(pt);
}




